--------------------------------------------------------------------------------
-- Copyright (c) 1995-2013 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 14.7
--  \   \         Application : sch2hdl
--  /   /         Filename : computer_drc.vhf
-- /___/   /\     Timestamp : 10/27/2019 14:31:16
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: /opt/Xilinx/14.7/ISE_DS/ISE/bin/lin/unwrapped/sch2hdl -sympath /home/mike/Documents/SimpleCpuDesign/simple_cpu_v1a_fpga/VHDL/simple_cpu_v1a/ipcore_dir -intstyle ise -family zynq -flat -suppress -vhdl computer_drc.vhf -w /home/mike/Documents/SimpleCpuDesign/simple_cpu_v1a_fpga/VHDL/simple_cpu_v1a/Src/computer.sch
--Design Name: computer
--Device: zynq
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--
----- CELL NOR8_HXILINX_computer -----
  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity NOR8_HXILINX_computer is
  
port(
    O  : out std_logic;

    I0  : in std_logic;
    I1  : in std_logic;
    I2  : in std_logic;
    I3  : in std_logic;
    I4  : in std_logic;
    I5  : in std_logic;
    I6  : in std_logic;
    I7  : in std_logic
  );
end NOR8_HXILINX_computer;

architecture NOR8_HXILINX_computer_V of NOR8_HXILINX_computer is
begin
  O <= not (I0 or I1 or I2 or I3 or I4 or I5 or I6 or I7);
end NOR8_HXILINX_computer_V;
----- CELL OR6_HXILINX_computer -----
  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity OR6_HXILINX_computer is
  
port(
    O  : out std_logic;

    I0  : in std_logic;
    I1  : in std_logic;
    I2  : in std_logic;
    I3  : in std_logic;
    I4  : in std_logic;
    I5  : in std_logic
  );
end OR6_HXILINX_computer;

architecture OR6_HXILINX_computer_V of OR6_HXILINX_computer is
begin
  O <=  (I0 or I1 or I2 or I3 or I4 or I5);
end OR6_HXILINX_computer_V;

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity buf4_MUSER_computer is
   port ( A : in    std_logic_vector (3 downto 0); 
          Y : out   std_logic_vector (3 downto 0));
end buf4_MUSER_computer;

architecture BEHAVIORAL of buf4_MUSER_computer is
   attribute BOX_TYPE   : string ;
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
begin
   XLXI_1 : BUF
      port map (I=>A(0),
                O=>Y(0));
   
   XLXI_2 : BUF
      port map (I=>A(1),
                O=>Y(1));
   
   XLXI_3 : BUF
      port map (I=>A(2),
                O=>Y(2));
   
   XLXI_4 : BUF
      port map (I=>A(3),
                O=>Y(3));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity buf8_MUSER_computer is
   port ( A : in    std_logic_vector (7 downto 0); 
          Y : out   std_logic_vector (7 downto 0));
end buf8_MUSER_computer;

architecture BEHAVIORAL of buf8_MUSER_computer is
   component buf4_MUSER_computer
      port ( A : in    std_logic_vector (3 downto 0); 
             Y : out   std_logic_vector (3 downto 0));
   end component;
   
begin
   XLXI_4 : buf4_MUSER_computer
      port map (A(3 downto 0)=>A(3 downto 0),
                Y(3 downto 0)=>Y(3 downto 0));
   
   XLXI_5 : buf4_MUSER_computer
      port map (A(3 downto 0)=>A(7 downto 4),
                Y(3 downto 0)=>Y(7 downto 4));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity nor_8_MUSER_computer is
   port ( A : in    std_logic_vector (7 downto 0); 
          Z : out   std_logic);
end nor_8_MUSER_computer;

architecture BEHAVIORAL of nor_8_MUSER_computer is
   attribute HU_SET     : string ;
   component NOR8_HXILINX_computer
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             I5 : in    std_logic; 
             I6 : in    std_logic; 
             I7 : in    std_logic; 
             O  : out   std_logic);
   end component;
   
   attribute HU_SET of XLXI_1 : label is "XLXI_1_0";
begin
   XLXI_1 : NOR8_HXILINX_computer
      port map (I0=>A(7),
                I1=>A(6),
                I2=>A(5),
                I3=>A(4),
                I4=>A(3),
                I5=>A(2),
                I6=>A(1),
                I7=>A(0),
                O=>Z);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity mux_2_MUSER_computer is
   port ( A   : in    std_logic; 
          B   : in    std_logic; 
          SEL : in    std_logic; 
          Y   : out   std_logic);
end mux_2_MUSER_computer;

architecture BEHAVIORAL of mux_2_MUSER_computer is
   attribute BOX_TYPE   : string ;
   signal XLXN_7  : std_logic;
   signal XLXN_8  : std_logic;
   signal XLXN_79 : std_logic;
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
begin
   XLXI_17 : AND2
      port map (I0=>XLXN_79,
                I1=>A,
                O=>XLXN_7);
   
   XLXI_18 : OR2
      port map (I0=>XLXN_8,
                I1=>XLXN_7,
                O=>Y);
   
   XLXI_19 : INV
      port map (I=>SEL,
                O=>XLXN_79);
   
   XLXI_20 : AND2
      port map (I0=>B,
                I1=>SEL,
                O=>XLXN_8);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity mux_2_8_MUSER_computer is
   port ( A   : in    std_logic_vector (7 downto 0); 
          B   : in    std_logic_vector (7 downto 0); 
          SEL : in    std_logic; 
          Y   : out   std_logic_vector (7 downto 0));
end mux_2_8_MUSER_computer;

architecture BEHAVIORAL of mux_2_8_MUSER_computer is
   component mux_2_MUSER_computer
      port ( Y   : out   std_logic; 
             SEL : in    std_logic; 
             B   : in    std_logic; 
             A   : in    std_logic);
   end component;
   
begin
   XLXI_1 : mux_2_MUSER_computer
      port map (A=>A(0),
                B=>B(0),
                SEL=>SEL,
                Y=>Y(0));
   
   XLXI_2 : mux_2_MUSER_computer
      port map (A=>A(1),
                B=>B(1),
                SEL=>SEL,
                Y=>Y(1));
   
   XLXI_3 : mux_2_MUSER_computer
      port map (A=>A(3),
                B=>B(3),
                SEL=>SEL,
                Y=>Y(3));
   
   XLXI_4 : mux_2_MUSER_computer
      port map (A=>A(2),
                B=>B(2),
                SEL=>SEL,
                Y=>Y(2));
   
   XLXI_5 : mux_2_MUSER_computer
      port map (A=>A(4),
                B=>B(4),
                SEL=>SEL,
                Y=>Y(4));
   
   XLXI_6 : mux_2_MUSER_computer
      port map (A=>A(5),
                B=>B(5),
                SEL=>SEL,
                Y=>Y(5));
   
   XLXI_7 : mux_2_MUSER_computer
      port map (A=>A(6),
                B=>B(6),
                SEL=>SEL,
                Y=>Y(6));
   
   XLXI_8 : mux_2_MUSER_computer
      port map (A=>A(7),
                B=>B(7),
                SEL=>SEL,
                Y=>Y(7));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity reg_4_MUSER_computer is
   port ( CE  : in    std_logic; 
          CLK : in    std_logic; 
          CLR : in    std_logic; 
          D   : in    std_logic_vector (3 downto 0); 
          Q   : out   std_logic_vector (3 downto 0));
end reg_4_MUSER_computer;

architecture BEHAVIORAL of reg_4_MUSER_computer is
   attribute BOX_TYPE   : string ;
   component FDCE
      generic( INIT : bit :=  '0');
      port ( C   : in    std_logic; 
             CE  : in    std_logic; 
             CLR : in    std_logic; 
             D   : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute BOX_TYPE of FDCE : component is "BLACK_BOX";
   
begin
   XLXI_41 : FDCE
      port map (C=>CLK,
                CE=>CE,
                CLR=>CLR,
                D=>D(0),
                Q=>Q(0));
   
   XLXI_42 : FDCE
      port map (C=>CLK,
                CE=>CE,
                CLR=>CLR,
                D=>D(1),
                Q=>Q(1));
   
   XLXI_43 : FDCE
      port map (C=>CLK,
                CE=>CE,
                CLR=>CLR,
                D=>D(2),
                Q=>Q(2));
   
   XLXI_44 : FDCE
      port map (C=>CLK,
                CE=>CE,
                CLR=>CLR,
                D=>D(3),
                Q=>Q(3));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity reg_8_MUSER_computer is
   port ( CE  : in    std_logic; 
          CLK : in    std_logic; 
          CLR : in    std_logic; 
          D   : in    std_logic_vector (7 downto 0); 
          Q   : out   std_logic_vector (7 downto 0));
end reg_8_MUSER_computer;

architecture BEHAVIORAL of reg_8_MUSER_computer is
   component reg_4_MUSER_computer
      port ( CE  : in    std_logic; 
             D   : in    std_logic_vector (3 downto 0); 
             CLR : in    std_logic; 
             CLK : in    std_logic; 
             Q   : out   std_logic_vector (3 downto 0));
   end component;
   
begin
   XLXI_1 : reg_4_MUSER_computer
      port map (CE=>CE,
                CLK=>CLK,
                CLR=>CLR,
                D(3 downto 0)=>D(3 downto 0),
                Q(3 downto 0)=>Q(3 downto 0));
   
   XLXI_2 : reg_4_MUSER_computer
      port map (CE=>CE,
                CLK=>CLK,
                CLR=>CLR,
                D(3 downto 0)=>D(7 downto 4),
                Q(3 downto 0)=>Q(7 downto 4));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity mux_3_8_MUSER_computer is
   port ( A    : in    std_logic_vector (7 downto 0); 
          B    : in    std_logic_vector (7 downto 0); 
          C    : in    std_logic_vector (7 downto 0); 
          SEL0 : in    std_logic; 
          SEL1 : in    std_logic; 
          Y    : out   std_logic_vector (7 downto 0));
end mux_3_8_MUSER_computer;

architecture BEHAVIORAL of mux_3_8_MUSER_computer is
   signal XLXN_8 : std_logic_vector (7 downto 0);
   component mux_2_8_MUSER_computer
      port ( B   : in    std_logic_vector (7 downto 0); 
             A   : in    std_logic_vector (7 downto 0); 
             SEL : in    std_logic; 
             Y   : out   std_logic_vector (7 downto 0));
   end component;
   
begin
   XLXI_1 : mux_2_8_MUSER_computer
      port map (A(7 downto 0)=>A(7 downto 0),
                B(7 downto 0)=>B(7 downto 0),
                SEL=>SEL0,
                Y(7 downto 0)=>XLXN_8(7 downto 0));
   
   XLXI_3 : mux_2_8_MUSER_computer
      port map (A(7 downto 0)=>XLXN_8(7 downto 0),
                B(7 downto 0)=>C(7 downto 0),
                SEL=>SEL1,
                Y(7 downto 0)=>Y(7 downto 0));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity and2_8_MUSER_computer is
   port ( A : in    std_logic_vector (7 downto 0); 
          B : in    std_logic_vector (7 downto 0); 
          Y : out   std_logic_vector (7 downto 0));
end and2_8_MUSER_computer;

architecture BEHAVIORAL of and2_8_MUSER_computer is
   attribute BOX_TYPE   : string ;
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
begin
   XLXI_1 : AND2
      port map (I0=>B(0),
                I1=>A(0),
                O=>Y(0));
   
   XLXI_2 : AND2
      port map (I0=>B(1),
                I1=>A(1),
                O=>Y(1));
   
   XLXI_3 : AND2
      port map (I0=>B(2),
                I1=>A(2),
                O=>Y(2));
   
   XLXI_4 : AND2
      port map (I0=>B(3),
                I1=>A(3),
                O=>Y(3));
   
   XLXI_5 : AND2
      port map (I0=>B(4),
                I1=>A(4),
                O=>Y(4));
   
   XLXI_6 : AND2
      port map (I0=>B(5),
                I1=>A(5),
                O=>Y(5));
   
   XLXI_7 : AND2
      port map (I0=>B(6),
                I1=>A(6),
                O=>Y(6));
   
   XLXI_8 : AND2
      port map (I0=>B(7),
                I1=>A(7),
                O=>Y(7));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity xor2_8_MUSER_computer is
   port ( A : in    std_logic_vector (7 downto 0); 
          B : in    std_logic; 
          Y : out   std_logic_vector (7 downto 0));
end xor2_8_MUSER_computer;

architecture BEHAVIORAL of xor2_8_MUSER_computer is
   attribute BOX_TYPE   : string ;
   component XOR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of XOR2 : component is "BLACK_BOX";
   
begin
   XLXI_1 : XOR2
      port map (I0=>B,
                I1=>A(0),
                O=>Y(0));
   
   XLXI_2 : XOR2
      port map (I0=>B,
                I1=>A(1),
                O=>Y(1));
   
   XLXI_3 : XOR2
      port map (I0=>B,
                I1=>A(2),
                O=>Y(2));
   
   XLXI_4 : XOR2
      port map (I0=>B,
                I1=>A(3),
                O=>Y(3));
   
   XLXI_5 : XOR2
      port map (I0=>B,
                I1=>A(5),
                O=>Y(5));
   
   XLXI_6 : XOR2
      port map (I0=>B,
                I1=>A(6),
                O=>Y(6));
   
   XLXI_7 : XOR2
      port map (I0=>B,
                I1=>A(7),
                O=>Y(7));
   
   XLXI_8 : XOR2
      port map (I0=>B,
                I1=>A(4),
                O=>Y(4));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity half_adder_MUSER_computer is
   port ( A     : in    std_logic; 
          B     : in    std_logic; 
          CARRY : out   std_logic; 
          SUM   : out   std_logic);
end half_adder_MUSER_computer;

architecture BEHAVIORAL of half_adder_MUSER_computer is
   attribute BOX_TYPE   : string ;
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
   component XOR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of XOR2 : component is "BLACK_BOX";
   
begin
   XLXI_1 : AND2
      port map (I0=>B,
                I1=>A,
                O=>CARRY);
   
   XLXI_2 : XOR2
      port map (I0=>B,
                I1=>A,
                O=>SUM);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity full_adder_MUSER_computer is
   port ( A    : in    std_logic; 
          B    : in    std_logic; 
          Cin  : in    std_logic; 
          Cout : out   std_logic; 
          SUM  : out   std_logic);
end full_adder_MUSER_computer;

architecture BEHAVIORAL of full_adder_MUSER_computer is
   attribute BOX_TYPE   : string ;
   signal XLXN_50 : std_logic;
   signal XLXN_59 : std_logic;
   signal XLXN_60 : std_logic;
   component half_adder_MUSER_computer
      port ( A     : in    std_logic; 
             B     : in    std_logic; 
             CARRY : out   std_logic; 
             SUM   : out   std_logic);
   end component;
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
begin
   XLXI_14 : half_adder_MUSER_computer
      port map (A=>A,
                B=>B,
                CARRY=>XLXN_59,
                SUM=>XLXN_50);
   
   XLXI_15 : half_adder_MUSER_computer
      port map (A=>XLXN_50,
                B=>Cin,
                CARRY=>XLXN_60,
                SUM=>SUM);
   
   XLXI_16 : OR2
      port map (I0=>XLXN_60,
                I1=>XLXN_59,
                O=>Cout);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity add_4_MUSER_computer is
   port ( A    : in    std_logic_vector (3 downto 0); 
          B    : in    std_logic_vector (3 downto 0); 
          CIN  : in    std_logic; 
          COUT : out   std_logic; 
          SUM  : out   std_logic_vector (3 downto 0));
end add_4_MUSER_computer;

architecture BEHAVIORAL of add_4_MUSER_computer is
   signal C0   : std_logic;
   signal C1   : std_logic;
   signal C2   : std_logic;
   component full_adder_MUSER_computer
      port ( A    : in    std_logic; 
             B    : in    std_logic; 
             Cin  : in    std_logic; 
             SUM  : out   std_logic; 
             Cout : out   std_logic);
   end component;
   
begin
   FA0 : full_adder_MUSER_computer
      port map (A=>A(0),
                B=>B(0),
                Cin=>CIN,
                Cout=>C0,
                SUM=>SUM(0));
   
   FA1 : full_adder_MUSER_computer
      port map (A=>A(1),
                B=>B(1),
                Cin=>C0,
                Cout=>C1,
                SUM=>SUM(1));
   
   FA2 : full_adder_MUSER_computer
      port map (A=>A(2),
                B=>B(2),
                Cin=>C1,
                Cout=>C2,
                SUM=>SUM(2));
   
   FA3 : full_adder_MUSER_computer
      port map (A=>A(3),
                B=>B(3),
                Cin=>C2,
                Cout=>COUT,
                SUM=>SUM(3));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity add_8_MUSER_computer is
   port ( A    : in    std_logic_vector (7 downto 0); 
          B    : in    std_logic_vector (7 downto 0); 
          CIN  : in    std_logic; 
          COUT : out   std_logic; 
          SUM  : out   std_logic_vector (7 downto 0));
end add_8_MUSER_computer;

architecture BEHAVIORAL of add_8_MUSER_computer is
   signal XLXN_11 : std_logic;
   component add_4_MUSER_computer
      port ( A    : in    std_logic_vector (3 downto 0); 
             CIN  : in    std_logic; 
             B    : in    std_logic_vector (3 downto 0); 
             SUM  : out   std_logic_vector (3 downto 0); 
             COUT : out   std_logic);
   end component;
   
begin
   XLXI_1 : add_4_MUSER_computer
      port map (A(3 downto 0)=>A(3 downto 0),
                B(3 downto 0)=>B(3 downto 0),
                CIN=>CIN,
                COUT=>XLXN_11,
                SUM(3 downto 0)=>SUM(3 downto 0));
   
   XLXI_2 : add_4_MUSER_computer
      port map (A(3 downto 0)=>A(7 downto 4),
                B(3 downto 0)=>B(7 downto 4),
                CIN=>XLXN_11,
                COUT=>COUT,
                SUM(3 downto 0)=>SUM(7 downto 4));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity add_sub_8_MUSER_computer is
   port ( A    : in    std_logic_vector (7 downto 0); 
          B    : in    std_logic_vector (7 downto 0); 
          CTL0 : in    std_logic; 
          C    : out   std_logic; 
          Y    : out   std_logic_vector (7 downto 0));
end add_sub_8_MUSER_computer;

architecture BEHAVIORAL of add_sub_8_MUSER_computer is
   signal XLXN_6 : std_logic_vector (7 downto 0);
   component add_8_MUSER_computer
      port ( A    : in    std_logic_vector (7 downto 0); 
             SUM  : out   std_logic_vector (7 downto 0); 
             B    : in    std_logic_vector (7 downto 0); 
             CIN  : in    std_logic; 
             COUT : out   std_logic);
   end component;
   
   component xor2_8_MUSER_computer
      port ( A : in    std_logic_vector (7 downto 0); 
             B : in    std_logic; 
             Y : out   std_logic_vector (7 downto 0));
   end component;
   
begin
   XLXI_86 : add_8_MUSER_computer
      port map (A(7 downto 0)=>A(7 downto 0),
                B(7 downto 0)=>XLXN_6(7 downto 0),
                CIN=>CTL0,
                COUT=>C,
                SUM(7 downto 0)=>Y(7 downto 0));
   
   XLXI_87 : xor2_8_MUSER_computer
      port map (A(7 downto 0)=>B(7 downto 0),
                B=>CTL0,
                Y(7 downto 0)=>XLXN_6(7 downto 0));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity alu_MUSER_computer is
   port ( A   : in    std_logic_vector (7 downto 0); 
          B   : in    std_logic_vector (7 downto 0); 
          CTL : in    std_logic_vector (2 downto 0); 
          Y   : out   std_logic_vector (7 downto 0));
end alu_MUSER_computer;

architecture BEHAVIORAL of alu_MUSER_computer is
   signal XLXN_30 : std_logic_vector (7 downto 0);
   signal XLXN_35 : std_logic_vector (7 downto 0);
   component add_sub_8_MUSER_computer
      port ( A    : in    std_logic_vector (7 downto 0); 
             B    : in    std_logic_vector (7 downto 0); 
             Y    : out   std_logic_vector (7 downto 0); 
             CTL0 : in    std_logic; 
             C    : out   std_logic);
   end component;
   
   component and2_8_MUSER_computer
      port ( A : in    std_logic_vector (7 downto 0); 
             B : in    std_logic_vector (7 downto 0); 
             Y : out   std_logic_vector (7 downto 0));
   end component;
   
   component mux_3_8_MUSER_computer
      port ( SEL0 : in    std_logic; 
             A    : in    std_logic_vector (7 downto 0); 
             B    : in    std_logic_vector (7 downto 0); 
             C    : in    std_logic_vector (7 downto 0); 
             SEL1 : in    std_logic; 
             Y    : out   std_logic_vector (7 downto 0));
   end component;
   
begin
   XLXI_39 : add_sub_8_MUSER_computer
      port map (A(7 downto 0)=>A(7 downto 0),
                B(7 downto 0)=>B(7 downto 0),
                CTL0=>CTL(0),
                C=>open,
                Y(7 downto 0)=>XLXN_30(7 downto 0));
   
   XLXI_40 : and2_8_MUSER_computer
      port map (A(7 downto 0)=>A(7 downto 0),
                B(7 downto 0)=>B(7 downto 0),
                Y(7 downto 0)=>XLXN_35(7 downto 0));
   
   XLXI_55 : mux_3_8_MUSER_computer
      port map (A(7 downto 0)=>XLXN_30(7 downto 0),
                B(7 downto 0)=>XLXN_35(7 downto 0),
                C(7 downto 0)=>B(7 downto 0),
                SEL0=>CTL(1),
                SEL1=>CTL(2),
                Y(7 downto 0)=>Y(7 downto 0));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity counter_8_MUSER_computer is
   port ( CE  : in    std_logic; 
          CLK : in    std_logic; 
          CLR : in    std_logic; 
          D   : in    std_logic_vector (7 downto 0); 
          LD  : in    std_logic; 
          Q   : out   std_logic_vector (7 downto 0));
end counter_8_MUSER_computer;

architecture BEHAVIORAL of counter_8_MUSER_computer is
   attribute BOX_TYPE   : string ;
   signal XLXN_1  : std_logic_vector (7 downto 0);
   signal XLXN_2  : std_logic_vector (7 downto 0);
   signal XLXN_3  : std_logic_vector (7 downto 0);
   signal XLXN_4  : std_logic;
   signal Q_DUMMY : std_logic_vector (7 downto 0);
   component reg_8_MUSER_computer
      port ( D   : in    std_logic_vector (7 downto 0); 
             CLK : in    std_logic; 
             CE  : in    std_logic; 
             CLR : in    std_logic; 
             Q   : out   std_logic_vector (7 downto 0));
   end component;
   
   component add_8_MUSER_computer
      port ( A    : in    std_logic_vector (7 downto 0); 
             SUM  : out   std_logic_vector (7 downto 0); 
             B    : in    std_logic_vector (7 downto 0); 
             CIN  : in    std_logic; 
             COUT : out   std_logic);
   end component;
   
   component mux_2_8_MUSER_computer
      port ( B   : in    std_logic_vector (7 downto 0); 
             A   : in    std_logic_vector (7 downto 0); 
             SEL : in    std_logic; 
             Y   : out   std_logic_vector (7 downto 0));
   end component;
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
begin
   XLXN_1(7 downto 0) <= x"00";
   Q(7 downto 0) <= Q_DUMMY(7 downto 0);
   XLXI_1 : reg_8_MUSER_computer
      port map (CE=>CE,
                CLK=>CLK,
                CLR=>CLR,
                D(7 downto 0)=>XLXN_2(7 downto 0),
                Q(7 downto 0)=>Q_DUMMY(7 downto 0));
   
   XLXI_2 : add_8_MUSER_computer
      port map (A(7 downto 0)=>XLXN_3(7 downto 0),
                B(7 downto 0)=>XLXN_1(7 downto 0),
                CIN=>XLXN_4,
                COUT=>open,
                SUM(7 downto 0)=>XLXN_2(7 downto 0));
   
   XLXI_3 : mux_2_8_MUSER_computer
      port map (A(7 downto 0)=>Q_DUMMY(7 downto 0),
                B(7 downto 0)=>D(7 downto 0),
                SEL=>LD,
                Y(7 downto 0)=>XLXN_3(7 downto 0));
   
   XLXI_4 : INV
      port map (I=>LD,
                O=>XLXN_4);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity onehot_decoder_16_MUSER_computer is
   port ( A0 : in    std_logic; 
          A1 : in    std_logic; 
          A2 : in    std_logic; 
          A3 : in    std_logic; 
          YA : out   std_logic; 
          YB : out   std_logic; 
          YC : out   std_logic; 
          YD : out   std_logic; 
          YE : out   std_logic; 
          YF : out   std_logic; 
          Y0 : out   std_logic; 
          Y1 : out   std_logic; 
          Y2 : out   std_logic; 
          Y3 : out   std_logic; 
          Y4 : out   std_logic; 
          Y5 : out   std_logic; 
          Y6 : out   std_logic; 
          Y7 : out   std_logic; 
          Y8 : out   std_logic; 
          Y9 : out   std_logic);
end onehot_decoder_16_MUSER_computer;

architecture BEHAVIORAL of onehot_decoder_16_MUSER_computer is
   attribute BOX_TYPE   : string ;
   signal not_A0 : std_logic;
   signal not_A1 : std_logic;
   signal not_A2 : std_logic;
   signal not_A3 : std_logic;
   component AND4
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND4 : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
begin
   XLXI_1 : AND4
      port map (I0=>not_A3,
                I1=>not_A2,
                I2=>not_A1,
                I3=>not_A0,
                O=>Y0);
   
   XLXI_2 : AND4
      port map (I0=>not_A3,
                I1=>not_A2,
                I2=>not_A1,
                I3=>A0,
                O=>Y1);
   
   XLXI_3 : AND4
      port map (I0=>not_A3,
                I1=>not_A2,
                I2=>A1,
                I3=>not_A0,
                O=>Y2);
   
   XLXI_4 : AND4
      port map (I0=>not_A3,
                I1=>not_A2,
                I2=>A1,
                I3=>A0,
                O=>Y3);
   
   XLXI_5 : AND4
      port map (I0=>not_A3,
                I1=>A2,
                I2=>not_A1,
                I3=>not_A0,
                O=>Y4);
   
   XLXI_6 : AND4
      port map (I0=>not_A3,
                I1=>A2,
                I2=>not_A1,
                I3=>A0,
                O=>Y5);
   
   XLXI_7 : AND4
      port map (I0=>not_A3,
                I1=>A1,
                I2=>A2,
                I3=>not_A0,
                O=>Y6);
   
   XLXI_8 : AND4
      port map (I0=>A3,
                I1=>not_A2,
                I2=>not_A1,
                I3=>not_A0,
                O=>Y8);
   
   XLXI_9 : AND4
      port map (I0=>A3,
                I1=>not_A2,
                I2=>not_A1,
                I3=>A0,
                O=>Y9);
   
   XLXI_19 : AND4
      port map (I0=>A3,
                I1=>not_A2,
                I2=>A1,
                I3=>not_A0,
                O=>YA);
   
   XLXI_20 : INV
      port map (I=>A3,
                O=>not_A3);
   
   XLXI_21 : INV
      port map (I=>A2,
                O=>not_A2);
   
   XLXI_22 : INV
      port map (I=>A1,
                O=>not_A1);
   
   XLXI_23 : INV
      port map (I=>A0,
                O=>not_A0);
   
   XLXI_52 : AND4
      port map (I0=>A3,
                I1=>not_A2,
                I2=>A1,
                I3=>A0,
                O=>YB);
   
   XLXI_53 : AND4
      port map (I0=>A3,
                I1=>A2,
                I2=>not_A1,
                I3=>not_A0,
                O=>YC);
   
   XLXI_54 : AND4
      port map (I0=>A3,
                I1=>A2,
                I2=>not_A1,
                I3=>A0,
                O=>YD);
   
   XLXI_55 : AND4
      port map (I0=>A3,
                I1=>A2,
                I2=>A1,
                I3=>not_A0,
                O=>YE);
   
   XLXI_56 : AND4
      port map (I0=>not_A3,
                I1=>A2,
                I2=>A1,
                I3=>A0,
                O=>Y7);
   
   XLXI_65 : AND4
      port map (I0=>A3,
                I1=>A2,
                I2=>A1,
                I3=>A0,
                O=>YF);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity ring_counter_3_MUSER_computer is
   port ( CLK : in    std_logic; 
          CLR : in    std_logic; 
          Q0  : out   std_logic; 
          Q1  : out   std_logic; 
          Q2  : out   std_logic);
end ring_counter_3_MUSER_computer;

architecture BEHAVIORAL of ring_counter_3_MUSER_computer is
   attribute BOX_TYPE   : string ;
   signal Q0_DUMMY : std_logic;
   signal Q1_DUMMY : std_logic;
   signal Q2_DUMMY : std_logic;
   component FDC
      generic( INIT : bit :=  '0');
      port ( C   : in    std_logic; 
             CLR : in    std_logic; 
             D   : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute BOX_TYPE of FDC : component is "BLACK_BOX";
   
   component FDP
      generic( INIT : bit :=  '1');
      port ( C   : in    std_logic; 
             D   : in    std_logic; 
             PRE : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute BOX_TYPE of FDP : component is "BLACK_BOX";
   
begin
   Q0 <= Q0_DUMMY;
   Q1 <= Q1_DUMMY;
   Q2 <= Q2_DUMMY;
   XLXI_75 : FDC
      port map (C=>CLK,
                CLR=>CLR,
                D=>Q0_DUMMY,
                Q=>Q1_DUMMY);
   
   XLXI_78 : FDP
      port map (C=>CLK,
                D=>Q2_DUMMY,
                PRE=>CLR,
                Q=>Q0_DUMMY);
   
   XLXI_116 : FDC
      port map (C=>CLK,
                CLR=>CLR,
                D=>Q1_DUMMY,
                Q=>Q2_DUMMY);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity control_logic_MUSER_computer is
   port ( CLK      : in    std_logic; 
          CLR      : in    std_logic; 
          D        : in    std_logic_vector (3 downto 0); 
          Z        : in    std_logic; 
          ACC_CTL0 : out   std_logic; 
          ACC_CTL1 : out   std_logic; 
          ACC_CTL2 : out   std_logic; 
          ACC_EN   : out   std_logic; 
          ADDR_SEL : out   std_logic; 
          DATA_SEL : out   std_logic; 
          IR_EN    : out   std_logic; 
          PC_EN    : out   std_logic; 
          PC_LD    : out   std_logic; 
          RAM_EN   : out   std_logic; 
          RAM_WR   : out   std_logic; 
          ROM_EN   : out   std_logic);
end control_logic_MUSER_computer;

architecture BEHAVIORAL of control_logic_MUSER_computer is
   attribute BOX_TYPE   : string ;
   attribute HU_SET     : string ;
   signal add         : std_logic;
   signal addm        : std_logic;
   signal bitwise_and : std_logic;
   signal decode      : std_logic;
   signal execute     : std_logic;
   signal fetch       : std_logic;
   signal jumpnz      : std_logic;
   signal jumpu       : std_logic;
   signal jumpz       : std_logic;
   signal load        : std_logic;
   signal move        : std_logic;
   signal store       : std_logic;
   signal sub         : std_logic;
   signal XLXN_58     : std_logic;
   signal XLXN_87     : std_logic;
   signal XLXN_110    : std_logic;
   signal XLXN_112    : std_logic;
   signal XLXN_116    : std_logic;
   signal XLXN_125    : std_logic;
   signal XLXN_135    : std_logic;
   signal XLXN_136    : std_logic;
   signal XLXN_354    : std_logic;
   signal XLXN_355    : std_logic;
   signal PC_LD_DUMMY : std_logic;
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : component is "BLACK_BOX";
   
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
   component OR3
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR3 : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component ring_counter_3_MUSER_computer
      port ( CLK : in    std_logic; 
             CLR : in    std_logic; 
             Q0  : out   std_logic; 
             Q1  : out   std_logic; 
             Q2  : out   std_logic);
   end component;
   
   component OR6_HXILINX_computer
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             I5 : in    std_logic; 
             O  : out   std_logic);
   end component;
   
   component onehot_decoder_16_MUSER_computer
      port ( A1 : in    std_logic; 
             A2 : in    std_logic; 
             A3 : in    std_logic; 
             A0 : in    std_logic; 
             Y0 : out   std_logic; 
             Y1 : out   std_logic; 
             Y2 : out   std_logic; 
             Y3 : out   std_logic; 
             Y4 : out   std_logic; 
             Y5 : out   std_logic; 
             Y6 : out   std_logic; 
             Y7 : out   std_logic; 
             Y8 : out   std_logic; 
             Y9 : out   std_logic; 
             YA : out   std_logic; 
             YB : out   std_logic; 
             YC : out   std_logic; 
             YD : out   std_logic; 
             YE : out   std_logic; 
             YF : out   std_logic);
   end component;
   
   attribute HU_SET of XLXI_91 : label is "XLXI_91_1";
begin
   PC_LD <= PC_LD_DUMMY;
   XLXI_9 : BUF
      port map (I=>fetch,
                O=>IR_EN);
   
   XLXI_11 : BUF
      port map (I=>fetch,
                O=>ROM_EN);
   
   XLXI_12 : OR2
      port map (I0=>execute,
                I1=>decode,
                O=>XLXN_58);
   
   XLXI_13 : AND2
      port map (I0=>XLXN_355,
                I1=>XLXN_58,
                O=>RAM_EN);
   
   XLXI_14 : AND2
      port map (I0=>store,
                I1=>execute,
                O=>RAM_WR);
   
   XLXI_15 : OR2
      port map (I0=>execute,
                I1=>decode,
                O=>XLXN_87);
   
   XLXI_17 : AND2
      port map (I0=>XLXN_355,
                I1=>XLXN_87,
                O=>ADDR_SEL);
   
   XLXI_19 : AND2
      port map (I0=>Z,
                I1=>jumpz,
                O=>XLXN_110);
   
   XLXI_20 : AND2
      port map (I0=>XLXN_116,
                I1=>jumpnz,
                O=>XLXN_112);
   
   XLXI_21 : OR3
      port map (I0=>XLXN_112,
                I1=>XLXN_110,
                I2=>jumpu,
                O=>PC_LD_DUMMY);
   
   XLXI_22 : INV
      port map (I=>Z,
                O=>XLXN_116);
   
   XLXI_23 : INV
      port map (I=>PC_LD_DUMMY,
                O=>XLXN_125);
   
   XLXI_24 : AND2
      port map (I0=>decode,
                I1=>XLXN_125,
                O=>XLXN_135);
   
   XLXI_25 : OR2
      port map (I0=>XLXN_136,
                I1=>XLXN_135,
                O=>PC_EN);
   
   XLXI_26 : AND2
      port map (I0=>execute,
                I1=>PC_LD_DUMMY,
                O=>XLXN_136);
   
   XLXI_28 : AND2
      port map (I0=>execute,
                I1=>XLXN_354,
                O=>ACC_EN);
   
   XLXI_86 : BUF
      port map (I=>bitwise_and,
                O=>ACC_CTL1);
   
   XLXI_88 : ring_counter_3_MUSER_computer
      port map (CLK=>CLK,
                CLR=>CLR,
                Q0=>fetch,
                Q1=>decode,
                Q2=>execute);
   
   XLXI_89 : OR3
      port map (I0=>addm,
                I1=>store,
                I2=>load,
                O=>XLXN_355);
   
   XLXI_90 : OR2
      port map (I0=>addm,
                I1=>load,
                O=>DATA_SEL);
   
   XLXI_91 : OR6_HXILINX_computer
      port map (I0=>addm,
                I1=>load,
                I2=>bitwise_and,
                I3=>sub,
                I4=>add,
                I5=>move,
                O=>XLXN_354);
   
   XLXI_92 : BUF
      port map (I=>sub,
                O=>ACC_CTL0);
   
   XLXI_93 : OR2
      port map (I0=>load,
                I1=>move,
                O=>ACC_CTL2);
   
   XLXI_94 : onehot_decoder_16_MUSER_computer
      port map (A0=>D(0),
                A1=>D(1),
                A2=>D(2),
                A3=>D(3),
                YA=>jumpnz,
                YB=>open,
                YC=>open,
                YD=>open,
                YE=>open,
                YF=>open,
                Y0=>move,
                Y1=>add,
                Y2=>sub,
                Y3=>bitwise_and,
                Y4=>load,
                Y5=>store,
                Y6=>addm,
                Y7=>open,
                Y8=>jumpu,
                Y9=>jumpz);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity reg_16_MUSER_computer is
   port ( CE  : in    std_logic; 
          CLK : in    std_logic; 
          CLR : in    std_logic; 
          D   : in    std_logic_vector (15 downto 0); 
          Q   : out   std_logic_vector (15 downto 0));
end reg_16_MUSER_computer;

architecture BEHAVIORAL of reg_16_MUSER_computer is
   component reg_8_MUSER_computer
      port ( D   : in    std_logic_vector (7 downto 0); 
             CLK : in    std_logic; 
             CE  : in    std_logic; 
             CLR : in    std_logic; 
             Q   : out   std_logic_vector (7 downto 0));
   end component;
   
begin
   XLXI_1 : reg_8_MUSER_computer
      port map (CE=>CE,
                CLK=>CLK,
                CLR=>CLR,
                D(7 downto 0)=>D(7 downto 0),
                Q(7 downto 0)=>Q(7 downto 0));
   
   XLXI_2 : reg_8_MUSER_computer
      port map (CE=>CE,
                CLK=>CLK,
                CLR=>CLR,
                D(7 downto 0)=>D(15 downto 8),
                Q(7 downto 0)=>Q(15 downto 8));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity simple_cpu_v1a_MUSER_computer is
   port ( CLK      : in    std_logic; 
          CLR      : in    std_logic; 
          DATA_IN  : in    std_logic_vector (15 downto 0); 
          ADDR     : out   std_logic_vector (7 downto 0); 
          DATA_OUT : out   std_logic_vector (15 downto 0); 
          RAM_EN   : out   std_logic; 
          RAM_WR   : out   std_logic; 
          ROM_EN   : out   std_logic);
end simple_cpu_v1a_MUSER_computer;

architecture BEHAVIORAL of simple_cpu_v1a_MUSER_computer is
   signal ACC      : std_logic_vector (7 downto 0);
   signal ACC_CTL  : std_logic_vector (2 downto 0);
   signal ACC_EN   : std_logic;
   signal ADDR_SEL : std_logic;
   signal ALU      : std_logic_vector (7 downto 0);
   signal B        : std_logic_vector (7 downto 0);
   signal data_sel : std_logic;
   signal IR       : std_logic_vector (15 downto 0);
   signal IR_EN    : std_logic;
   signal PC       : std_logic_vector (7 downto 0);
   signal PC_EN    : std_logic;
   signal PC_LD    : std_logic;
   signal XLXN_167 : std_logic;
   signal XLXN_192 : std_logic_vector (3 downto 0);
   component counter_8_MUSER_computer
      port ( Q   : out   std_logic_vector (7 downto 0); 
             D   : in    std_logic_vector (7 downto 0); 
             CLK : in    std_logic; 
             CE  : in    std_logic; 
             LD  : in    std_logic; 
             CLR : in    std_logic);
   end component;
   
   component reg_8_MUSER_computer
      port ( D   : in    std_logic_vector (7 downto 0); 
             CLK : in    std_logic; 
             CE  : in    std_logic; 
             CLR : in    std_logic; 
             Q   : out   std_logic_vector (7 downto 0));
   end component;
   
   component reg_16_MUSER_computer
      port ( Q   : out   std_logic_vector (15 downto 0); 
             CLK : in    std_logic; 
             CE  : in    std_logic; 
             CLR : in    std_logic; 
             D   : in    std_logic_vector (15 downto 0));
   end component;
   
   component mux_2_8_MUSER_computer
      port ( B   : in    std_logic_vector (7 downto 0); 
             A   : in    std_logic_vector (7 downto 0); 
             SEL : in    std_logic; 
             Y   : out   std_logic_vector (7 downto 0));
   end component;
   
   component alu_MUSER_computer
      port ( B   : in    std_logic_vector (7 downto 0); 
             A   : in    std_logic_vector (7 downto 0); 
             CTL : in    std_logic_vector (2 downto 0); 
             Y   : out   std_logic_vector (7 downto 0));
   end component;
   
   component control_logic_MUSER_computer
      port ( IR_EN    : out   std_logic; 
             PC_EN    : out   std_logic; 
             PC_LD    : out   std_logic; 
             D        : in    std_logic_vector (3 downto 0); 
             CLK      : in    std_logic; 
             CLR      : in    std_logic; 
             ACC_EN   : out   std_logic; 
             ACC_CTL2 : out   std_logic; 
             ACC_CTL1 : out   std_logic; 
             ACC_CTL0 : out   std_logic; 
             ADDR_SEL : out   std_logic; 
             DATA_SEL : out   std_logic; 
             RAM_EN   : out   std_logic; 
             RAM_WR   : out   std_logic; 
             ROM_EN   : out   std_logic; 
             Z        : in    std_logic);
   end component;
   
   component nor_8_MUSER_computer
      port ( A : in    std_logic_vector (7 downto 0); 
             Z : out   std_logic);
   end component;
   
   component buf8_MUSER_computer
      port ( A : in    std_logic_vector (7 downto 0); 
             Y : out   std_logic_vector (7 downto 0));
   end component;
   
   component buf4_MUSER_computer
      port ( A : in    std_logic_vector (3 downto 0); 
             Y : out   std_logic_vector (3 downto 0));
   end component;
   
begin
   XLXN_192(3 downto 0) <= x"0";
   XLXI_1 : counter_8_MUSER_computer
      port map (CE=>PC_EN,
                CLK=>CLK,
                CLR=>CLR,
                D(7 downto 0)=>IR(7 downto 0),
                LD=>PC_LD,
                Q(7 downto 0)=>PC(7 downto 0));
   
   XLXI_2 : reg_8_MUSER_computer
      port map (CE=>ACC_EN,
                CLK=>CLK,
                CLR=>CLR,
                D(7 downto 0)=>ALU(7 downto 0),
                Q(7 downto 0)=>ACC(7 downto 0));
   
   XLXI_3 : reg_16_MUSER_computer
      port map (CE=>IR_EN,
                CLK=>CLK,
                CLR=>CLR,
                D(15 downto 0)=>DATA_IN(15 downto 0),
                Q(15 downto 0)=>IR(15 downto 0));
   
   XLXI_4 : mux_2_8_MUSER_computer
      port map (A(7 downto 0)=>IR(7 downto 0),
                B(7 downto 0)=>DATA_IN(7 downto 0),
                SEL=>data_sel,
                Y(7 downto 0)=>B(7 downto 0));
   
   XLXI_5 : alu_MUSER_computer
      port map (A(7 downto 0)=>ACC(7 downto 0),
                B(7 downto 0)=>B(7 downto 0),
                CTL(2 downto 0)=>ACC_CTL(2 downto 0),
                Y(7 downto 0)=>ALU(7 downto 0));
   
   XLXI_6 : mux_2_8_MUSER_computer
      port map (A(7 downto 0)=>PC(7 downto 0),
                B(7 downto 0)=>IR(7 downto 0),
                SEL=>ADDR_SEL,
                Y(7 downto 0)=>ADDR(7 downto 0));
   
   XLXI_8 : control_logic_MUSER_computer
      port map (CLK=>CLK,
                CLR=>CLR,
                D(3 downto 0)=>IR(15 downto 12),
                Z=>XLXN_167,
                ACC_CTL0=>ACC_CTL(0),
                ACC_CTL1=>ACC_CTL(1),
                ACC_CTL2=>ACC_CTL(2),
                ACC_EN=>ACC_EN,
                ADDR_SEL=>ADDR_SEL,
                DATA_SEL=>data_sel,
                IR_EN=>IR_EN,
                PC_EN=>PC_EN,
                PC_LD=>PC_LD,
                RAM_EN=>RAM_EN,
                RAM_WR=>RAM_WR,
                ROM_EN=>ROM_EN);
   
   XLXI_9 : nor_8_MUSER_computer
      port map (A(7 downto 0)=>ACC(7 downto 0),
                Z=>XLXN_167);
   
   XLXI_14 : buf8_MUSER_computer
      port map (A(7 downto 0)=>ACC(7 downto 0),
                Y(7 downto 0)=>DATA_OUT(7 downto 0));
   
   XLXI_15 : buf4_MUSER_computer
      port map (A(3 downto 0)=>IR(11 downto 8),
                Y(3 downto 0)=>DATA_OUT(15 downto 12));
   
   XLXI_16 : buf4_MUSER_computer
      port map (A(3 downto 0)=>XLXN_192(3 downto 0),
                Y(3 downto 0)=>DATA_OUT(11 downto 8));
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity computer is
   port ( CLK : in    std_logic; 
          CLR : in    std_logic);
end computer;

architecture BEHAVIORAL of computer is
   attribute BOX_TYPE   : string ;
   signal ADDR     : std_logic_vector (7 downto 0);
   signal clk10MHz : std_logic;
   signal DATA_IN  : std_logic_vector (15 downto 0);
   signal DATA_OUT : std_logic_vector (15 downto 0);
   signal RAM_WR   : std_logic;
   signal sync_rst : std_logic;
   signal XLXN_2   : std_logic;
   signal XLXN_16  : std_logic;
   signal XLXN_23  : std_logic;
   component clock10MHz
      port ( clk_in1  : in    std_logic; 
             clk_out1 : out   std_logic; 
             reset    : in    std_logic; 
             locked   : out   std_logic);
   end component;
   
   component simple_cpu_v1a_MUSER_computer
      port ( DATA_IN  : in    std_logic_vector (15 downto 0); 
             DATA_OUT : out   std_logic_vector (15 downto 0); 
             ADDR     : out   std_logic_vector (7 downto 0); 
             RAM_EN   : out   std_logic; 
             RAM_WR   : out   std_logic; 
             ROM_EN   : out   std_logic; 
             CLK      : in    std_logic; 
             CLR      : in    std_logic);
   end component;
   
   component ram_256x16_sim
      port ( CLK      : in    std_logic; 
             EN       : in    std_logic; 
             WE       : in    std_logic; 
             DUMP     : in    std_logic; 
             DATA_IN  : in    std_logic_vector (15 downto 0); 
             DATA_OUT : out   std_logic_vector (15 downto 0); 
             ADDR_IN  : in    std_logic_vector (7 downto 0));
   end component;
   
   component async_reset
      port ( clk         : in    std_logic; 
             locked      : in    std_logic; 
             reset_in    : in    std_logic; 
             reset_out   : out   std_logic; 
             reset_out_n : out   std_logic);
   end component;
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
begin
   CLOCK : clock10MHz
      port map (clk_in1=>CLK,
                reset=>CLR,
                clk_out1=>clk10MHz,
                locked=>XLXN_2);
   
   CPU : simple_cpu_v1a_MUSER_computer
      port map (CLK=>clk10MHz,
                CLR=>sync_rst,
                DATA_IN(15 downto 0)=>DATA_IN(15 downto 0),
                ADDR(7 downto 0)=>ADDR(7 downto 0),
                DATA_OUT(15 downto 0)=>DATA_OUT(15 downto 0),
                RAM_EN=>open,
                RAM_WR=>RAM_WR,
                ROM_EN=>open);
   
   MEMORY : ram_256x16_sim
      port map (ADDR_IN(7 downto 0)=>ADDR(7 downto 0),
                CLK=>clk10MHz,
                DATA_IN(15 downto 0)=>DATA_OUT(15 downto 0),
                DUMP=>XLXN_16,
                EN=>XLXN_23,
                WE=>RAM_WR,
                DATA_OUT(15 downto 0)=>DATA_IN(15 downto 0));
   
   RESET : async_reset
      port map (clk=>clk10MHz,
                locked=>XLXN_2,
                reset_in=>CLR,
                reset_out=>sync_rst,
                reset_out_n=>open);
   
   XLXI_5 : GND
      port map (G=>XLXN_16);
   
   XLXI_7 : VCC
      port map (P=>XLXN_23);
   
end BEHAVIORAL;


